%define anolis_release 2.0.1

Name: liburing
Version: 2.3
Release: %{anolis_release}%{?dist}
Summary: Linux-native io_uring I/O access library
License: LGPLv2+
Source: %{name}-%{version}.tar.bz2
URL: http://brick.kernel.dk/snaps/%{name}-%{version}.tar.bz2
BuildRequires: gcc
# Begin: Anolis customized patches
Patch1001: 1001-Add-percpu-io-sq-thread-support.patch
Patch1002: 1002-support-us-granularity-of-io_sq_thread_idle.patch
Patch1003: 1003-add-IORING_ENTER_SQ_SUBMIT_ON_IDLE-flag.patch
Patch1004: 1004-Add-a-test-for-sqpoll-sq_thread_idle_us-mode.patch
Patch1005: 1005-test-io_uring_passthrough-skip-if-kernel-doesn-t-sup.patch
Patch1006: 1006-test-io_uring_passthrough-fix-iopoll-test.patch
Patch1007: 1007-test-io_uring_passthrough-cleanup-invalid-submission.patch
Patch1008: 1008-test-io_uring_passthrough-skip-test-if-bit-sqe-cqe-s.patch
Patch1009: 1009-test-read-before-exit-handle-IOPOLL-failure-on-older.patch
Patch1010: 1010-test-sqpoll-idle-us-add-SQ_AFF-flag.patch
# End: Anolis customized patches

%description
Provides native async IO for the Linux kernel, in a fast and efficient
manner, for both buffered and O_DIRECT.

%package devel
Summary: Development files for Linux-native io_uring I/O access library
Requires: %{name} = %{version}-%{release}
Requires: pkgconfig

%description devel
This package provides header files to include and libraries to link with
for the Linux-native io_uring.

%prep
%autosetup -p1

%build
./configure --prefix=%{_prefix} --libdir=/%{_libdir} --libdevdir=/%{_libdir} --mandir=%{_mandir} --includedir=%{_includedir}

%make_build V=1

%install
%make_install

%files
%attr(0755,root,root) %{_libdir}/liburing.so.*
%doc COPYING

%files devel
%{_includedir}/liburing/
%{_includedir}/liburing.h
%{_libdir}/liburing.so
%{_libdir}/liburing.a
%{_libdir}/pkgconfig/*
%{_mandir}/man2/*
%{_mandir}/man3/*
%{_mandir}/man7/*

%changelog
* Tue Oct 10 2023 Ferry Meng <mengferry@linux.alibaba.com> - 2.3-2.0.1
- update read-before-exit and sqpoll-idle-us tests

* Tue Jun 20 2023 Joseph Qi <joseph.qi@linux.alibaba.com> - 2.3-2
- update to liburing-2.3 to io_uring_passthrough

* Tue Apr 18 2023 Ziyang Zhang <ZiyangZhang@linux.alibaba.com> - 1.0.7-3.0.4
- fix IORING_OP_URING_CMD incompatible issue

* Mon Mar 13 2023 Ziyang Zhang <ZiyangZhang@linux.alibaba.com> - 1.0.7-3.0.3
- Add IORING_SETUP_SQE128 support and tests
- Add IORING_OP_URING_CMD support

* Tue Dec 6 2022 Ziyang Zhang <ZiyangZhang@linux.alibaba.com> - 1.0.7-3.0.2
- revert io_uring ioctl support
- update uapi for IORING_ENTER_SQ_SUBMIT_ON_IDLE
- add a test for sqpoll sq_thread_idle_us mode

* Mon Nov 29 2021 Hao Xu <haoxu@linux.alibaba.com> - 1.0.7-3.0.1
- add anolis customized patches to support features in Anolis OS Kernel

* Thu Aug 20 2020 Jeff Moyer <jmoyer@redhat.com> - 1.0.7-3.el8
- Build with V=1 so that the build logs are useful.
- Related: rhbz#1862551

* Thu Aug 20 2020 Jeff Moyer <jmoyer@redhat.com> - 1.0.7-2.el8
- Fix versioning.  The installed library is 1.0.7, make the rpm match.
- bump release number for build, which includes -fPIC fix
- Related: rhbz#1862551

* Fri Jul 31 2020 Jeff Moyer <jmoyer@redhat.com> - 0.7-1.el8
- Update to upstream version 0.7.
- Resolves: 1862551

* Wed Nov  6 2019 Jeff Moyer <jmoyer@redhat.com> - 0.2-2.el8
- bump release to trigger gating tests
- Related: bz#1724804

* Thu Oct 31 2019 Jeff Moyer <jmoyer@redhat.com> - 0.2-1
- Initial rhel8 package.
- Resolves: bz#1724804

* Tue Jan 8 2019 Jens Axboe <axboe@kernel.dk> - 0.1
- Initial version
